tellraw @a {"translate":"bungeon.updated_1111", "fallback":"%s%s", "color":"green", "with":[{"text":"Please download the valid Ressource Pack from ", "color":"red"},{"text":"Modrinth", "color":"green", "underlined":true, "clickEvent":{"action":"open_url","value":"https://modrinth.com/datapack/enter-the-bungeon/version/1.1.1.1"},"hoverEvent":{"action":"show_text","contents":["Can be found at the bottom"]}}]}

# Upgrades
data modify storage bungeon:data upgrade set value [ \
    {rarity:2,modifiers:[{type:"pierce",amount:1},{type:"bullet_speed",amount:-20},{type:"damage",amount:-10}]}, \
    {rarity:0,modifiers:[{type:"speed",amount:10},{type:"health",amount:-5}]}, \
    {rarity:1,modifiers:[{type:"attack_speed",amount:20},{type:"spread",amount:10},{type:"damage",amount:-5}]}, \
    {rarity:0,modifiers:[{type:"health",amount:15},{type:"damage",amount:-5}]}, \
    {rarity:2,modifiers:[{type:"damage",amount:20},{type:"spread",amount:-15},{type:"attack_speed",amount:-10}]}, \
    {rarity:0,modifiers:[{type:"bullet_speed",amount:30},{type:"damage",amount:-5}]}, \
    {rarity:2,modifiers:[{type:"lifesteal",amount:10},{type:"armor",amount:-5}]}, \
    {rarity:1,modifiers:[{type:"room_heal",amount:15},{type:"lifesteal",amount:-3}]}, \
    {rarity:2,modifiers:[{type:"damage",amount:30},{type:"blood_loss",amount:5,scaled:1b}]}, \
    {rarity:1,modifiers:[{type:"damage",amount:10},{type:"health",amount:5},{type:"speed",amount:-10}]}, \
    {rarity:0,modifiers:[{type:"attack_speed",amount:10},{type:"damage",amount:-2}]}, \
    {rarity:3,modifiers:[{type:"bullet_bounce",amount:20},{type:"bullet_speed",amount:-25}]}, \
    {rarity:3,modifiers:[{type:"fatal_grace",amount:1}]}, \
    {rarity:3,modifiers:[{type:"reroll",amount:20},{type:"upgrade_coins",amount:-3,path:"run.stats."}]}, \
    {rarity:2,modifiers:[{type:"dare_damage",amount:40},{type:"damage",amount:-10}]}, \
    {rarity:1,modifiers:[{type:"thorns",amount:20},{type:"armor",amount:5},{type:"speed",amount:-15}]}, \
    {rarity:1,modifiers:[{type:"item_slots",amount:1},{type:"speed",amount:-10},{type:"damage",amount:-5}]}, \
    {rarity:0,modifiers:[{type:"enemy_coins",amount:15,path:"run.stats."},{type:"enemy_health",amount:10,path:"run.stats."}]}, \
    {rarity:3,modifiers:[{type:"thorn_damage",amount:-2},{type:"damage",amount:-15}]}, \
    {rarity:3,modifiers:[{type:"flawless_coins",amount:20},{type:"hit_coins",amount:-1}]}, \
    {rarity:1,modifiers:[{type:"poison_chance",amount:15},{type:"health",amount:-10},{type:"damage",amount:-5}]}, \
    {rarity:2,modifiers:[{type:"first_hit",amount:50},{type:"attack_speed",amount:-10}]}, \
    {rarity:2,modifiers:[{type:"damage_poison",amount:20},{type:"poison_strength",amount:-5,scaled:1b},{type:"damage",amount:-5}]}, \
    {rarity:0,modifiers:[{type:"attack_speed",amount:10},{type:"crit_chance",amount:3},{type:"damage",amount:-5}]}, \
    {rarity:0,modifiers:[{type:"crit_damage",amount:10},{type:"damage",amount:-3}]}, \
    {rarity:1,modifiers:[{type:"hit_coins",amount:3},{type:"enemy_coins",amount:-30}]}, \
    {rarity:2,modifiers:[{type:"heal_coins",amount:20},{type:"heal",amount:-15}]}, \
    {rarity:3,modifiers:[{type:"damage_coins",amount:2,scaled:1b},{type:"hit_coinp",amount:-1}]}, \
    {rarity:2,modifiers:[{type:"lifesteal_crit",amount:10},{type:"lifesteal",amount:-5}]}, \
    {rarity:2,modifiers:[{type:"attack_speed",amount:15},{type:"speed",amount:10},{type:"crit_chance",amount:-3}]}, \
    {rarity:2,modifiers:[{type:"crit_chance",amount:5},{type:"dodge",amount:5},{type:"poison_chance",amount:-10}]}, \
    {rarity:1,modifiers:[{type:"thorns",amount:35},{type:"damage",amount:5},{type:"dodge",amount:-3}]}, \
    {rarity:3,modifiers:[{type:"damage",amount:35},{type:"health",amount:-50}]}, \
    {rarity:3,modifiers:[{type:"parry_reflect",amount:100},{type:"parry_time",amount:-3,seconds:1b}]}, \
    {rarity:1,modifiers:[{type:"poison_duration",seconds:1b,amount:30},{type:"poison_strength",amount:5,scaled:1b},{type:"damage",amount:-10}]}, \
    {rarity:2,modifiers:[{type:"knockback",amount:50},{type:"crit_chance",amount:-5}]} \
]

# Upgrade Rarity
data modify storage bungeon:data rarity set value [ \
    {color:"yellow", price:15, upgrades:[]}, \
    {color:"green", price:25, upgrades:[]}, \
    {color:"aqua", price:35, upgrades:[]}, \
    {color:"light_purple", price:50, upgrades:[]} \
]

# Generate Lookup Tables
execute store result storage bungeon:main num int 1 run scoreboard players set #raycast bungeon.temp 0
function bungeon:load/update/generate/rarity with storage bungeon:main


# Scaling
data modify storage bungeon:data difficulty set value { \
health:          [100,120], \
damage:          [100,130], \
attack_cooldown: [100,85], \
attack_speed:    [10,11], \
attack_range:    [10,15] \
}

data modify storage bungeon:data floor set value { \
health: [1.0,1.4,1.9,2.4,3.,3.6,4.5,5.], \
speed:  [1.0,1.1,1.15,1.2,1.25,1.3,1.35,1.4,1.45,1.5], \
jump:   [1.0,1.02,1.04,1.06,1.08,1.1,1.12,1.14,1.16,1.18,2.0], \
damage: [1.0,1.3,1.7,2.,2.5,3.,4.5,5.], \
waves:  ["190..200","195..200","198..200","100..350","100..450"] \
}


# Data
data modify storage bungeon:data item set value { \
sword:         {damage:45, speed:1500, crit_chance:5, poison_chance:0, knockback:0.3, melee:true}, \
auto_rifle:    {damage:15, decay:15, spread:10, bullet_speed:80, pierce:0, speed:200, crit_chance:0, poison_chance:0, bullet_amount:1, knockback:0.05}, \
revolver:      {damage:60, decay:20, spread:5, bullet_speed:170, pierce:0, speed:1000, crit_chance:0, poison_chance:0, bullet_amount:1, knockback:0.2}, \
shotgun:       {damage:30, decay:8, spread:100, bullet_speed:100, pierce:0, speed:2000, crit_chance:0, poison_chance:0, bullet_amount:5, knockback:0.1}, \
health_potion: {health:50} \
}

data modify storage bungeon:data enemy set value { \
zombie:      {weight:3,health:28,damage:12,speed:0.20,jump:0.38,coins:3,health_height:0.2,health_scale:1,id:"zombie",entity:"minecraft:zombie",nbt:"",attributes:"",tags:"",data:""}, \
slime:       {weight:3,health:18,damage:10,speed:0.5,jump:0.4,coins:0,health_height:0.2,health_scale:1,id:"slime",entity:"minecraft:slime",nbt:",Size:1",attributes:"",tags:"",data:""}, \
small_slime: {weight:1,health:5,damage:5,speed:0.55,jump:0.35,coins:1,health_scale:0.75,health_height:0.15,id:"small_slime",entity:"minecraft:slime",nbt:"",attributes:"",tags:"",data:""}, \
skeleton:    {weight:2,health:15,damage:8,speed:0.20,jump:0.38,coins:2,health_height:0.2,health_scale:1,id:"skeleton",entity:"minecraft:skeleton",nbt:",HandItems:[{id:\"minecraft:bow\"},{}]",attributes:"",tags:"",data:""}, \
ghost:       {weight:2,health:22,damage:10,speed:0.6,jump:0,coins:2,health_height:0.15,health_scale:1,id:"ghost",entity:"minecraft:wandering_trader",hitbox:"minecraft:interaction ~ ~ ~ {width:1,height:1.5,Tags:[\"this\",\"hitbox\",\"clear_run\"],Passengers:[{id:\"minecraft:marker\",Tags:[\"data\",\"enemy\",\"ghost\",\"clear_run\"]}]}",nbt:",Offers:{Recipes:[]}",attributes:",{id:\"minecraft:step_height\",base:1}",tags:"",data:",immune:{knockback:1b}"}, \
crystal:     {weight:2,health:15,damage:50,speed:0.6,jump:0,coins:2,health_height:0.15,health_scale:1,id:"crystal",entity:"minecraft:wandering_trader",hitbox:"minecraft:interaction ~ ~ ~ {width:1,height:1.5,Tags:[\"this\",\"hitbox\",\"clear_run\"],Passengers:[{id:\"minecraft:marker\",Tags:[\"data\",\"enemy\",\"crystal\",\"clear_run\"]}]}",nbt:",Offers:{Recipes:[]}",attributes:",{id:\"minecraft:step_height\",base:1}",tags:"",data:",immune:{knockback:1b}"}, \
golem:       {health:300,speed:0.6,jump:0.38,coins:50,nobar:1b,id:"golem",entity:"minecraft:wandering_trader",hitbox:"",nbt:",NoAI:1b,Offers:{Recipes:[]}",attributes:",{id:\"minecraft:follow_range\",base:0d},{id:\"minecraft:scale\",base:2d}",tags:",\"boss\"",data:",immune:{knockback:1b,poison:1b}"} \
}

data modify storage bungeon:data room set value [[ \
    {corner:[9,0,9], wall:[8,8], hallways:[{pos:"^ ^ ^8", rot:0},{pos:"^ ^ ^8", rot:90},{pos:"^ ^ ^8", rot:180},{pos:"^ ^ ^8", rot:270}]}, \
    {corner:[6,0,6], wall:[6,6], hallways:[{pos:"^ ^ ^6",rot:0},{pos:"^1 ^ ^6", rot:90},{pos:"^1 ^ ^6", rot:270}], enemy_amount:"6..8", locations:{item:"^ ^1 ^-2", exit:"^ ^ ^-2", prop:[{pos:"^5 ^ ^3"},{pos:"^4 ^ ^-5"},{pos:"^-3 ^ ^-5"},{pos:"^-5 ^ ^-4"}], enemy:[{pos:"^ ^ ^",size:36}]}}, \
    {corner:[7,0,7], wall:[7,7], hallways:[{pos:"^2 ^ ^7", rot:0},{pos:"^-4 ^ ^7",rot:90},{pos:"^ ^ ^7", rot:180},{pos:"^ ^ ^7", rot:270}], enemy_amount:"6..12", locations:{item:"^-4 ^1 ^4", exit:"^ ^ ^", prop:[{pos:"^-4 ^ ^-5"},{pos:"^-1 ^ ^-5"},{pos:"^4 ^ ^-5"},{pos:"^6 ^ ^-4"},{pos:"^6 ^ ^2"},{pos:"^5 ^ ^6"},{pos:"^ ^ ^6"},{pos:"^-5 ^2 ^3"},{pos:"^-3 ^2 ^6"}], enemy:[{pos:"^-4 ^2 ^5",size:8},{pos:"^-5 ^2 ^1",size:8},{pos:"^-4 ^ ^-4",size:18},{pos:"^2 ^ ^-2",size:37},{pos:"^2 ^ ^3",size:28}]}}, \
    {corner:[9,0,9], wall:[9,9], hallways:[{pos:"^-4 ^ ^9", rot:0},{pos:"^ ^ ^9", rot:90},{pos:"^-1 ^ ^9", rot:180},{pos:"^-3 ^ ^9", rot:270}], enemy_amount:"10..15", locations:{item:"^6 ^1 ^-4", exit:"^1 ^ ^", prop:[{pos:"^-4 ^ ^-5"},{pos:"^6 ^ ^-7"},{pos:"^8 ^ ^"},{pos:"^6 ^ ^7"},{pos:"^-1 ^ ^8"},{pos:"^8 ^3 ^6"},{pos:"^-7 ^ ^7"},{pos:"^-8 ^ ^3"}], enemy:[{pos:"^-4 ^ ^4",size:38},{pos:"^-6 ^ ^-1",size:15},{pos:"^4 ^ ^-4",size:29},{pos:"^4 ^ ^1",size:28},{pos:"^6 ^3 ^6.5",size:10}]}}, \
    {corner:[8,-4,8], wall:[8,8], hallways:[{pos:"^ ^ ^8", rot:180},{pos:"^ ^ ^8", rot:270}], enemy_amount:"6..12", locations:{item:"^-3 ^1 ^-1", exit:"^3 ^ ^2", pits:[{pos:"^6 ^ ^-6.5",x:3,z:2},{pos:"^3 ^ ^3",x:5,z:5},{pos:"^-5 ^ ^-4",x:5,z:7}], prop:[{pos:"^-6 ^ ^1"},{pos:"^ ^ ^5"},{pos:"^6 ^ ^7"},{pos:"^7 ^ ^1"},{pos:"^7 ^ ^-5"},{pos:"^4 ^ ^-5"}], enemy:[{pos:"^4 ^ ^-3",size:24},{pos:"^-1 ^ ^-3",size:29},{pos:"^6 ^ ^6",size:5}]}} \
]]

# Length: [full, z]
data modify storage bungeon:data hallway set value [[ \
    {length:[4,0]}, \
    {length:[4,0]}, \
]]

data modify storage bungeon:data format set value {rotation:{name:{0:"none",90:"clockwise_90",180:"180",270:"counterclockwise_90"}, neg:{0:180,90:270,180:0,270:90}, dxz:{0:"positioned ~ ~ ~ as @p[dx=2, dz=0]",90:"positioned ~-1 ~ ~ as @p[dx=0, dz=2]",180:"positioned ~-3 ~ ~-1 as @p[dx=2, dz=0]",270:"positioned ~ ~ ~-3 as @p[dx=0, dz=2]"}}}

data modify storage bungeon:data tips set value [ \
    {prefix:"    ", lore:['{"translate":"bungeon.gui.tips.0.0", "with":[{"keybind":"key.swapOffhand"}], "color":"white", "italic":false}','{"translate":"bungeon.gui.tips.0.1", "color":"white", "italic":false}']}, \
    {prefix:"   ", lore:['{"translate":"bungeon.gui.tips.1.0", "with":[{"keybind":"key.drop"}], "color":"white", "italic":false}', '{"translate":"bungeon.gui.tips.1.1", "color":"white", "italic":false}']}, \
    {prefix:"      ", lore:['{"translate":"bungeon.gui.tips.2.0", "with":[{"keybind":"key.sneak"}], "color":"white", "italic":false}','{"translate":"bungeon.gui.tips.2.1", "color":"white", "italic":false}']}, \
    {prefix:"            ", lore:['{"translate":"bungeon.gui.tips.3.0", "color":"white", "italic":false}', '{"translate":"bungeon.gui.tips.3.1", "color":"white", "italic":false}']}, \
    {prefix:"                ", lore:['{"translate":"bungeon.gui.tips.4.0", "color":"white", "italic":false}', '{"translate":"bungeon.gui.tips.4.1", "color":"white", "italic":false}', '{"translate":"bungeon.gui.tips.4.2", "color":"white", "italic":false}']}, \
    {prefix:"           ", lore:['{"translate":"bungeon.gui.tips.5.0", "color":"white", "italic":false}', '{"translate":"bungeon.gui.tips.5.1", "color":"white", "italic":false}']} \
]

# This is generated by the python script in the lang directory
data modify storage bungeon:data dialogue set value {'tutorial.intro0': 16, 'tutorial.intro1': 31, 'tutorial.intro2': 7, 'tutorial.intro3': 34, 'tutorial.explain0': 24, 'tutorial.explain1': 25, 'tutorial.explain2': 27, 'tutorial.sword0': 26, 'tutorial.sword1': 27, 'tutorial.upgrade0': 32, 'tutorial.upgrade1': 30, 'tutorial.outro0': 21, 'tutorial.outro1': 4, 'post_golem.0': 18, 'post_golem.1': 20, 'post_golem.2': 25, 'post_golem.3': 27, 'post_golem.first_run': 22, 'post_golem.many_runs': 12}


# Return if soft update (dev only)
execute if data storage bungeon:main {version:-1} run return fail


# FIXME turn this into a version check like the player script
execute unless data storage bungeon:main progression run data modify storage bungeon:main progression set value {golem:0b}
data modify storage bungeon:main option set value {connected_lives:false, enemy_health_text:true, difficulty:0}

# Things i use for the map, loot table support and rules when dead 
fill -64 101 -64 64 101 64 black_concrete
setblock 0 100 0 chest
team add dead {"translate":"bungeon.team.dead"}
team modify dead collisionRule pushOtherTeams
team modify dead nametagVisibility hideForOtherTeams
team modify dead seeFriendlyInvisibles true

# Buildings
kill @e[type=!player]
summon marker 0. 0 0. {Tags:["direction_calculator"]}
place template bungeon:hub -6 7 -22
execute positioned 0.5 21 -12. run function animated_java:death_toggle/summon {args:{}}
execute unless data storage bungeon:main {reset:false} run function bungeon:load/update/reset
execute unless data storage bungeon:main {tutorial:false} run return run function bungeon:load/update/tutorial

# Final
setworldspawn 0 20 -9
tp @a 0 20 -9 0 0
scoreboard players set #mode bungeon.temp 0